#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
# LJR : liste les subnets GREENs

require '/var/smoothwall/header.pl';

my (%cgiparams, %checked, %selected);
my $filename = "${swroot}/listgreens/config";
my %netsettings;

&showhttpheaders();

&readhash("${swroot}/ppp/settings", \%pppsettings);
&readhash("${swroot}/ethernet/settings", \%netsettings);

$cgiparams{'ENABLED'} = 'off';
&getcgihash(\%cgiparams);

my $errormessage = '';

if ($cgiparams{'ACTION'} eq $tr{'add'})
{
	unless(&validipormask($cgiparams{'SRC'}))
	{
		if ($cgiparams{'SRC'} ne '') {
			$errormessage = $tr{'source is bad'}; }
		else {
			$cgiparams{'SRC'} = '0.0.0.0/0'; }
	}
	unless(&validipormask($cgiparams{'MASK'}))
	{
		if ($cgiparams{'MASK'} ne '') {
			$errormessage = $tr{'mask is bad'}; }
		else {
			$cgiparams{'MASK'} = '0.0.0.0/0'; }
	}
	open(FILE, $filename) or die 'Unable to open config file.';
	my @current = <FILE>;
	close(FILE);
	unless ($errormessage)
	{
		open(FILE,">>$filename") or die 'Unable to open config file.';
		flock FILE, 2;
		print FILE "$cgiparams{'SRC'},$cgiparams{'MASK'},$cgiparams{'ENABLED'}\n";
		close(FILE);
		undef %cgiparams;
		&log($tr{'internal lan added'});
                system('/usr/local/bin/setglan');
	}
	
}
if ($cgiparams{'ACTION'} eq $tr{'remove'} || $cgiparams{'ACTION'} eq $tr{'edit'})
{
	open(FILE, "$filename") or die 'Unable to open config file.';
	my @current = <FILE>;
	close(FILE);

	my $count = 0;
	my $id = 0;
	my $line;
	foreach $line (@current)
	{
		$id++;
		if ($cgiparams{$id} eq "on") {
			$count++; }
	}
	if ($count == 0) {
		$errormessage = $tr{'nothing selected'}; }
	if ($count > 1 && $cgiparams{'ACTION'} eq $tr{'edit'}) {
		$errormessage = $tr{'you can only select one item to edit'}; }
	unless ($errormessage)
	{
		open(FILE, ">$filename") or die 'Unable to open config file.';
		flock FILE, 2;
		my $id = 0;
		foreach $line (@current)
		{
			$id++;
			unless ($cgiparams{$id} eq "on") {
				print FILE "$line"; }
			elsif ($cgiparams{'ACTION'} eq $tr{'edit'})
			{
				chomp($line);
				my @temp = split(/\,/,$line);
				$cgiparams{'SRC'} = $temp[0];
				$cgiparams{'MASK'} = $temp[1];
				$cgiparams{'ENABLED'} = $temp[2];
			}
		}
		close(FILE);
		&log($tr{'internal lan removed'});
                system('/usr/local/bin/setglan');
	}
}
if ($cgiparams{'ACTION'} eq '')
{
	$cgiparams{'ENABLED'} = 'on';
}

$checked{'ENABLED'}{'off'} = '';
$checked{'ENABLED'}{'on'} = '';  
$checked{'ENABLED'}{$cgiparams{'ENABLED'}} = 'CHECKED';

&openpage($tr{'internal access configuration'}, 1, '');

&showservicessection();

&openbigbox('100%', 'LEFT');

print "<FORM METHOD='POST'>\n";

&openbox('100%', 'LEFT', $tr{'add a new internal host or lan'});
print <<END
<TABLE WIDTH='100%'>
<TR>
<TD CLASS='base'><FONT COLOR='$colourred'>$tr{'netgsource'}</FONT></TD>
<TD><INPUT TYPE='TEXT' NAME='SRC' VALUE='$cgiparams{'SRC'}' SIZE='18'></TD>
<TD CLASS='base'><FONT COLOR='$colourred'>$tr{'netgmask'}</FONT></TD>
<TD><INPUT TYPE='TEXT' NAME='MASK' VALUE='$cgiparams{'MASK'}' SIZE='18'></TD>
</TR>
</TABLE>
<TABLE WIDTH='100%'>
<TR>
<TD CLASS='base' WIDTH='50%' ALIGN='CENTER'>$tr{'enabled'}<INPUT TYPE='CHECKBOX' NAME='ENABLED' $checked{'ENABLED'}{'on'}></TD>
<TD WIDTH='50%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='$tr{'add'}'></TD>
</TR>
</TABLE>
END
;
&closebox();

&openbox('100%', 'LEFT', $tr{'current lans'});
print <<END
<TABLE WIDTH='100%'>
<TR>
<TD WIDTH='40%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'source'}</B></TD>
<TD WIDTH='40%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'mask'}</B></TD>
<TD WIDTH='10%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'enabledtitle'}</B></TD>
<TD WIDTH='10%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'mark'}</B></TD>
</TR>
END
;

my $id = 0;
open(RULES, "$filename") or die 'Unable to open config file.';
while (<RULES>)
{
	$id++;
	chomp($_);
	my @temp = split(/\,/,$_);
	my $gif = '';
	if ($id % 2) {
		print "<TR BGCOLOR='$table1colour'>\n"; }
	else {
              	print "<TR BGCOLOR='$table2colour'>\n"; }
	if ($temp[2] eq 'on') { $gif = 'on.gif'; }
		else { $gif = 'off.gif'; }
	if ($temp[0] eq '0.0.0.0/0') {
		$temp[0] = $tr{'all'}; }
print <<END
<TD ALIGN='CENTER'>$temp[0]</TD>
<TD ALIGN='CENTER'>$temp[1]</TD>
<TD ALIGN='CENTER'>$temp[2]</TD>
<TD ALIGN='CENTER'><IMG SRC='/images/$gif'></TD>
<TD ALIGN='CENTER'><INPUT TYPE='CHECKBOX' NAME='$id'></TD>
</TR>
END
	;
}
close(RULES);

print <<END
</TABLE>
<TABLE WIDTH='100%'>
<TR>
<TD WIDTH='50%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='$tr{'remove'}'></TD>
<TD WIDTH='50%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='$tr{'edit'}'></TD>
</TR>
</TABLE>
END
;
&closebox();

&openbox('100%', 'LEFT', $tr{'error messages'});
print "<CLASS NAME='base'>$errormessage\n";
print "&nbsp;</CLASS>\n";
&closebox();

&closebigbox();

&closepage();

